#!/usr/bin/env perl

use strict;
use warnings;
use Carp ();

use SQL::SplitStatement ();
use Text::Diff;

my $verbatim_splitter = SQL::SplitStatement->new(
    keep_terminators      => 1,
    keep_extra_spaces     => 1,
    keep_comments         => 1,
    keep_empty_statements => 1
   );

sub body {
    my $_in_fileName = shift;

    my $l_in_h;
    my $l_out_h;
    unless (open $l_in_h, '<', $_in_fileName) {
         warn "open '$_in_fileName' fail!, descr: $@.";
         next;
     }
    my @l_linee = map {$_ =~ s/\r\n/\n/;$_} <$l_in_h>;
    close $l_in_h;

    my $p_sql_stm = join("", @l_linee);
    my @verbatim_statements = $verbatim_splitter->split($p_sql_stm);
    my $l_sql_stm_out = join ('', @verbatim_statements);
    printf "chk: %s\n",$_in_fileName;
    if ($p_sql_stm eq $l_sql_stm_out) {
        print "  OK!\n";
    } else {
        print "  NOOK\n";
    }
    printf "  statements:%s!\n",scalar(@verbatim_statements);
    printf "  len input :%s!\n",length($p_sql_stm);
    printf "  len output:%s!\n",length($l_sql_stm_out);
    printf "  diff = %s\n", diff \$p_sql_stm,   \$l_sql_stm_out;
    my $_out_fileName = $_in_fileName.'output.sql';
    open $l_out_h, '>', $_out_fileName or die "open '$_out_fileName' fail!, descr: $@.";
    print $l_out_h $l_sql_stm_out;
    close $l_out_h;
}

unless (@ARGV) {
    print "usage: $0 <sql_file_name_list>\n";
    exit;
}

foreach my $l_in_pathName (@ARGV){
    body ($l_in_pathName);
}

__END__
